#!/usr/bin/perl
use Mysql;

#    MailWorld SQL v1.4 - maillist management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

open (F, "<mworld.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}
$dbh=Mysql->connect($mysqlhost,$mysqldb,$mysqllogin,$mysqlpassword);

read (STDIN,$query,$ENV{CONTENT_LENGTH});
@query=split("&",$query);
foreach (@query)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9A-Fa-f]{2})/pack('C',hex($1))/eg;
		$data{$field}=$value;
	}
}
$data{type}=1 if (!$data{type} || $data{type}=~/\D+/);
if (!$data{name})
{
	push (@errors,"Incorrect <b>name</b>, you must put first and last name<br>\n");
	$flag=1;
}
unless ($data{email}=~/^[\w\-.]+\@{1}[\w\-.]+$/ && $data{email}=~/^\w+/ && $data{email}=~/\w+$/)
{
	push (@errors,"Incorrect <b>e-mail</b>, you must put your e-mail address<br>\n");
	$flag=1;
}
if ($data{password}=~/\W+/ || $data{password} eq "")
{
	push (@errors,"Incorrect <b>password</b>, must be one word<br>\n");
	$flag=1;
}
$sth=$dbh->query("LOCK TABLES mw_users READ") if ($locktables);
$sth=$dbh->query("SELECT uid FROM mw_users WHERE email='$data{email}'");
$uid=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if ($uid)
{
	push (@errors,"You can register only one mailing list per email address<br>\n");
	$flag=1;
}
$sth=$dbh->query("LOCK TABLES mw_acctype READ") if ($locktables);
$sth=$dbh->query("SELECT atid FROM mw_acctype WHERE atid=$data{type}");
$atid=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
unless ($atid)
{
	push (@errors,"Unknown account type, please contact <a href=\"mailto:$email\">administrator</a> about this error.<br>\n");
	$flag=1;
}
&closedb;
&error(@errors) if ($flag);
open (F,"<$mwpath/template/confirm.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;

sub error
{
@errors=@_;
open (F,"<$mwpath/template/error.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("\n",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub closedb
{
$sth="";
$dbh="";
}
