#!/usr/bin/perl
use Mysql;
use Socket;

#    MailWorld SQL v1.4 - maillist management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

open (F, "<mworld.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}
$dbh=Mysql->connect($mysqlhost,$mysqldb,$mysqllogin,$mysqlpassword);

read (STDIN,$query,$ENV{CONTENT_LENGTH});
@query=split("&",$query);
foreach (@query)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9A-Fa-f]{2})/pack('C',hex($1))/eg;
		$data{$field}=$value;
	}
}

$data{type}=1 if (!$data{type} || $data{type}=~/\D+/);
if (!$data{name})
{
	push (@errors,"Incorrect <b>name</b>, you must put first and last name<br>\n");
	$flag=1;
}
unless ($data{email}=~/^[\w\-.]+\@{1}[\w\-.]+$/ && $data{email}=~/^\w+/ && $data{email}=~/\w+$/)
{
	push (@errors,"Incorrect <b>e-mail</b>, you must put your e-mail address<br>\n");
	$flag=1;
}
$sth=$dbh->query("LOCK TABLES mw_users READ") if ($locktables);
$sth=$dbh->query("SELECT uid FROM mw_users WHERE email='$data{email}'");
$uid=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if ($uid)
{
	push (@errors,"You can register only one mailing list per email address<br>\n");
	$flag=1;
}
$sth=$dbh->query("LOCK TABLES mw_acctype READ") if ($locktables);
$sth=$dbh->query("SELECT atid,autoaccept FROM mw_acctype WHERE atid=$data{type}");
($atid,$autoaccept)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
unless ($atid)
{
	push (@errors,"Unknown account type, please contact <a href=\"mailto:$email\">administrator</a> about this error.<br>\n");
	$flag=1;
}
&error(@errors) if ($flag);
$data{name}=~s/'/APOSTROPHH/g;
$sth=$dbh->query("LOCK TABLES mw_users WRITE") if ($locktables);
$sth=$dbh->query("INSERT INTO mw_users (email,password,name,acctype,status) VALUES ('$data{email}','$data{password}','$data{name}',$data{type},$autoaccept)");
$sth=$dbh->query("SELECT LAST_INSERT_ID()");
$uid=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("CREATE TABLE mw_subscr_$uid (sid MEDIUMINT(8) UNSIGNED NOT NULL auto_increment,lid MEDIUMINT(8) UNSIGNED NOT NULL,email VARCHAR(255),status TINYINT(1),PRIMARY KEY (sid),INDEX (lid,email))");
$sth=$dbh->query("CREATE TABLE mw_history_$uid (hid BIGINT(11) UNSIGNED NOT NULL auto_increment,lid MEDIUMINT(8) UNSIGNED NOT NULL,statd DATETIME NOT NULL,subject VARCHAR(255),message TEXT,PRIMARY KEY (hid),INDEX (lid,statd))");
$sth=$dbh->query("LOCK TABLES mw_alist WRITE") if ($locktables);
$sth=$dbh->query("SELECT sid FROM mw_alist WHERE email='$data{email}'");
$sid=$sth->fetchrow;
unless ($sid)
{
	$sth=$dbh->query("INSERT INTO mw_alist (email) VALUES ('$data{email}')");
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES mw_lists WRITE") if ($locktables);
$sth=$dbh->query("INSERT INTO mw_lists (uid,lname,subj,mstyle) VALUES ($uid,'Default','Default subject',0)");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES mw_settings READ") if ($locktables);
$sth=$dbh->query("SELECT aheader,afooter,uheader,ufooter FROM mw_settings");
($raheader,$rafooter,$ruheader,$rufooter)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$data{name}=~s/APOSTROPHH/'/g;
$raheader=~s/APOSTROPHH/'/g;
$rafooter=~s/APOSTROPHH/'/g;
$ruheader=~s/APOSTROPHH/'/g;
$rufooter=~s/APOSTROPHH/'/g;
unless ($autoaccept)
{
if ($smtpserver)
{
	$header=$ruheader;
	$bottom=$rufooter;
	&sendviasmtp("$email ($owntitle)",$data{email},"Welcome to MailWorld","$header\nCongratulations! Your account has been registered successfully. Please wait for your account approval. After this you can login to members section to get HTML code and manage your account:\n\n$mailworld/members.html and use\nLogin: $data{email}\nPassword: $data{password}\n\n$bottom");
}
else
{
open (MAIL,"|$progmail");
print MAIL "To: $data{email}\n";
print MAIL "From: $email ($owntitle)\n";
print MAIL "Subject: Welcome to MailWorld\n\n";
print MAIL $ruheader;
print MAIL "Congratulations! Your account has been registered successfully. Please wait for your account approval. After this you can login to members section to get HTML code and manage your account:\n\n";
print MAIL "$mailworld/members.html and use\nLogin: $data{email}\nPassword: $data{password}\n\n";
print MAIL $rufooter;
print MAIL "\n.\n";
close (MAIL);
}
if ($smtpserver)
{
	$header=$raheader;
	$bottom=$rafooter;
	&sendviasmtp("$email ($owntitle)",$email,"New User Information - Approval required","$header\nName: $data{name}\nEmail: $data{email}\nPassword: $data{password}\n$bottom");
}
else
{
open (MAIL,"|$progmail");
print MAIL "To: $email\n";
print MAIL "From: $data{email} ($data{Name})\n";
print MAIL "Subject: New User Information - Approval required\n\n";
print MAIL $raheader;
print MAIL "Name: $data{name}\n";
print MAIL "Email: $data{email}\n";
print MAIL "Password: $data{password}\n";
print MAIL $rafooter;
print MAIL "\n.\n";
close (MAIL);
}
&closedb;
open (F,"<$mwpath/template/success1.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
}
else
{
if ($smtpserver)
{
	$header=$ruheader;
	$bottom=$rufooter;
	&sendviasmtp("$email ($owntitle)",$data{email},"Welcome to MailWorld","$header\nCongratulations! Your account has been registered successfully. Please login to members section to get HTML code and manage your account:\n\n$mailworld/members.html and use\nLogin: $data{email}\nPassword: $data{password}\n\n$bottom");
}
else
{
open (MAIL,"|$progmail");
print MAIL "To: $data{email}\n";
print MAIL "From: $email ($owntitle)\n";
print MAIL "Subject: Welcome to MailWorld\n\n";
print MAIL $ruheader;
print MAIL "Congratulations! Your account has been registered successfully. Please login to members section to get HTML code and manage your account:\n\n";
print MAIL "$mailworld/members.html and use\nLogin: $data{email}\nPassword: $data{password}\n\n";
print MAIL $rufooter;
print MAIL "\n.\n";
close (MAIL);
}
if ($smtpserver)
{
	$header=$raheader;
	$bottom=$rafooter;
	&sendviasmtp("$email ($owntitle)",$email,"New User Information","$header\nName: $data{name}\nEmail: $data{email}\nPassword: $data{password}\n$bottom");
}
else
{
open (MAIL,"|$progmail");
print MAIL "To: $email\n";
print MAIL "From: $data{email} ($data{Name})\n";
print MAIL "Subject: New User Information\n\n";
print MAIL $raheader;
print MAIL "Name: $data{name}\n";
print MAIL "Email: $data{email}\n";
print MAIL "Password: $data{password}\n";
print MAIL $rafooter;
print MAIL "\n.\n";
close (MAIL);
}
&closedb;
open (F,"<$mwpath/template/success.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
}

sub error
{
@errors=@_;
&closedb;
open (F,"<$mwpath/template/error.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub sendviasmtp
{
($from,$to,$subject,$message)=@_;
$message=~s/\n/\r\n/g;
$localhost=(gethostbyname('localhost'))[0] || 'localhost';
socket(S,PF_INET,SOCK_STREAM,(getprotobyname('tcp'))[2]) || return;
$farg=sockaddr_in($smtpport,inet_aton($smtpserver)) || return;
connect(S,$farg) || return("err$!");
$res=<S>;
if ($res=~/^[45]/){close(S);return;}
$mes="HELO $localhost\r\n";
$len=length($mes);
syswrite(S,$mes,$len);
$res=<S>;
if ($res=~/^[45]/){close(S);return;}
$mes="mail from: <$email>\r\n";
$len=length($mes);
syswrite(S,$mes,$len);
$res=<S>;
if ($res=~/^[45]/){close(S);return;}
$mes="rcpt to: <$to>\r\n";
$len=length($mes);
syswrite(S,$mes,$len);
$res=<S>;
if ($res=~/^[45]/){close(S);return;}
$mes="data\r\n";
$len=length($mes);
syswrite(S,$mes,$len);
$res=<S>;
$mes="From:$from\r\nTo:$to\r\nSubject:$subject\r\n";
$len=length($mes);
syswrite(S,$mes,$len);
$mes="\r\n$message\r\n.\r\n";
$len=length($mes);
syswrite(S,$mes,$len);
$res=<S>;
if ($res=~/^[45]/){close(S);return;}
$mes="quit\r\n";
$len=length($mes);
syswrite(S,$mes,$len);
$res=<S>;
close(S);
}
sub closedb
{
$sth="";
$dbh="";
}
