#!/usr/bin/perl
use Socket;
use Mysql;

#    MailWorld SQL v1.4 - maillist management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

open (F, "<mworld.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}
$dbh=Mysql->connect($mysqlhost,$mysqldb,$mysqllogin,$mysqlpassword);

if ($ENV{CONTENT_LENGTH}>0){read (STDIN,$query,$ENV{CONTENT_LENGTH});}
else {($query=$ENV{QUERY_STRING});}
@query=split("&",$query);
foreach (@query)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9A-Fa-f]{2})/pack('C',hex($1))/eg;
		$data{$field}=$value;
	}
}
if (!$data{email})
{
	&closedb;
	open (F,"<$mwpath/template/unsub.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
if (!$data{uid} || !$data{lid} || $data{uid}=~/\D+/ || $data{lid}=~/\D+/)
{
	&closedb;
	push (@errors,"Wrong parameters, possible error in registration form<br>\n");
	open (F,"<$mwpath/template/error.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
if ($data{destination})
{
	&closedb;
	push (@errors,"Wrong parameters, possible error in unsubscribe form<br>\n");
	open (F,"<$mwpath/template/error.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
$sth=$dbh->query("LOCK TABLES mw_users READ") if ($locktables);
$sth=$dbh->query("SELECT uid,email,status,acctype FROM mw_users WHERE uid=$data{uid}");
($uid,$data{From},$status,$type)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
unless ($uid)
{
	&closedb;
	push (@errors,"Unknown account, possible account was removed<br>\n");
	open (F,"<$mwpath/template/error.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
if ($status==0)
{
	&closedb;
	push (@errors,"Account is not approved yet<br>\n");
	open (F,"<$mwpath/template/error.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
if ($status==2)
{
	&closedb;
	push (@errors,"Account is disabled<br>\n");
	open (F,"<$mwpath/template/error.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
$sth=$dbh->query("LOCK TABLES mw_lists READ") if ($locktables);
$sth=$dbh->query("SELECT lid,mstyle,header,footer FROM mw_lists WHERE (uid=$data{uid} AND lid=$data{lid})");
($lid,$mstyle,$header,$footer)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$header=~s/APOSTROPHH/'/g;
$footer=~s/APOSTROPHH/'/g;
unless ($lid)
{
	&closedb;
	push (@errors,"Unknown maillist, possible account was removed<br>\n");
	open (F,"<$mwpath/template/error.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
unless ($data{email}=~/^[\w\-.]+\@{1}[\w\-.]+$/ && $data{email}=~/^\w+/ && $data{email}=~/\w+$/)
{
	&closedb;
	push (@errors,"Incorrect <b>e-mail</b>, you must put your e-mail address<br>\n");
	open (F,"<$mwpath/template/error.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
$sth=$dbh->query("LOCK TABLES mw_acctype READ") if ($locktables);
$sth=$dbh->query("SELECT allowsend,maxsubscr,maxlist,autoaccept,allowsends,validation,limitpermonth,advert,archive,addfeat,usedomain,advertad FROM mw_acctype WHERE atid=$type");
($allowsend,$maxsubscr,$maxlist,$autoaccept,$allowsends,$validation,$limitpermonth,$advert,$archive,$addfeat,$usedomain,$advertad)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$advertad=~s/APOSTROPHH/'/g;
if ($advert){$footer=$advertad;}
if ($usedomain)
{
	($data{From},$garb)=split(/\@/,$data{From});
	$furl=~s/http\:\/\///;
	($furl,$garb)=split(/\//,$furl);
	@furl=split(/\./,$furl);
	$domain=pop(@furl);
	$data{From}=$data{From}."\@".pop(@furl).".".$domain;
}
if ($mstyle){$footer=~s/\n/\<br\>\n/g;}
$sth=$dbh->query("LOCK TABLES mw_subscr_$data{uid} READ") if ($locktables);
$sth=$dbh->query("SELECT sid FROM mw_subscr_$data{uid} WHERE (lid=$data{lid} AND email='$data{email}')");
$sid=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
unless ($sid)
{
	&closedb;
	push (@errors,"Your <b>e-mail</b> is not exist in our maillist<br>\n");
	open (F,"<$mwpath/template/error.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
$sth=$dbh->query("LOCK TABLES mw_subscr_$data{uid} WRITE") if ($locktables);
$sth=$dbh->query("DELETE FROM mw_subscr_$data{uid} WHERE sid=$sid");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$fromemail=$data{From};
if ($smtpserver)
{
	$bottom=$footer;
	&sendviasmtp("$fromemail",$data{email},"Unsubscribing confirmation","$header\nYour email $data{email} was unsubscribed from our maillist successfully\n\n$bottom");
}
else
{
open (MAIL,"|$progmail");
print MAIL "To: $data{email}\n";
print MAIL "From: $fromemail\n";
print MAIL "Subject: Unsubscribing confirmation\n\n";
print MAIL $header;
print MAIL "Your email $data{email} was unsubscribed from our maillist successfully\n\n";
print MAIL $footer;
print MAIL "\n.\n";
close (MAIL);
}
&closedb;
open (F,"<$mwpath/template/unsubscr.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
sub sendviasmtp
{
($from,$to,$subject,$message)=@_;
$message=~s/\n/\r\n/g;
$localhost=(gethostbyname('localhost'))[0] || 'localhost';
socket(S,PF_INET,SOCK_STREAM,(getprotobyname('tcp'))[2]) || return;
$farg=sockaddr_in($smtpport,inet_aton($smtpserver)) || return;
connect(S,$farg) || return("err$!");
$res=<S>;
if ($res=~/^[45]/){close(S);return;}
$mes="HELO $localhost\r\n";
$len=length($mes);
syswrite(S,$mes,$len);
$res=<S>;
if ($res=~/^[45]/){close(S);return;}
$mes="mail from: <$email>\r\n";
$len=length($mes);
syswrite(S,$mes,$len);
$res=<S>;
if ($res=~/^[45]/){close(S);return;}
$mes="rcpt to: <$to>\r\n";
$len=length($mes);
syswrite(S,$mes,$len);
$res=<S>;
if ($res=~/^[45]/){close(S);return;}
$mes="data\r\n";
$len=length($mes);
syswrite(S,$mes,$len);
$res=<S>;
$mes="From:$from\r\nTo:$to\r\nSubject:$subject\r\nContent-type:$data{Content}\r\n";
$len=length($mes);
syswrite(S,$mes,$len);
$mes="\r\n$message\r\n.\r\n";
$len=length($mes);
syswrite(S,$mes,$len);
$res=<S>;
if ($res=~/^[45]/){close(S);return;}
$mes="quit\r\n";
$len=length($mes);
syswrite(S,$mes,$len);
$res=<S>;
close(S);
}
sub closedb
{
$sth="";
$dbh="";
}
